/* $Workfile: OsaLinuxSpi.h $   $Revision: 4 $    $Modtime: 10/30/07 5:41p $  */
/*******************************************************************************

  Odin TeleSystems Inc.

  OTX Telecom Adapter Driver

  @doc internal

  @module

  @normal Copyright (C) Odin TeleSystems Inc., 2007, All Rights Reserved

*******************************************************************************/

#ifndef OSA_LINUX_SPI_H
#define OSA_LINUX_SPI_H


#include "../OsaRtl.h"  // For wchar_t with C compile
//#include <asm/io.h>
//#include <asm/arch/gio.h>


#ifdef __cplusplus
extern "C" {
#else
#endif

// The SPI has a 16K command beffer Host->DMP, and a 16k status/event buffer
// DMP->host. The two buffers were defined by the SPI hardware/driver interface.
#define OSA_SPI_COMMAND_BUFFER        0
#define OSA_SPI_STATUS_EVENT_BUFFER   1

extern OsaBool32 OsaLinuxSpiIsOpen(void);

extern int OsaLinuxSpiOpen(void);
extern int OsaLinuxSpiClose(void);

extern int OsaLinuxSpiRead16(OsaUint16 nAddress, OsaUint16 *nData, OsaUint16 nType);
extern int OsaLinuxSpiWrite16(OsaUint16 nAddress, OsaUint16 nData, OsaUint16 nType);

extern int OsaLinuxSpiReadBuffer(OsaUint16 *nData, OsaUint16 nType);
extern int OsaLinuxSpiWriteBuffer(OsaUint16 *nData, OsaUint16 nType);

// SPI work around for buffer only access. Not able to access an address
// (single word) only a buffer of data.
extern int OsaLinuxSpiGetReadBuffer(OsaUint16 nType);
extern int OsaLinuxSpiSendWriteBuffer(OsaUint16 nType);

#ifdef __cplusplus
}
#endif

#endif  // OSA_LINUX_SPI_H

